︠a30f8fa9-28f4-49e3-bf33-a0a826aa05db︠

%md
### Adleman algorithm for the discrete logarithm problem
︡a126e64a-300d-460a-ba65-6da5b173ad23︡{"done":true,"md":"### Adleman algorithm for the discrete logarithm problem"}
︠3cd11cb1-500e-486e-b251-b3eec31c6c97s︠
from numpy import *
import tree as tr
import sys

sys.setrecursionlimit(10000)
print("recursion limit = %s"%(sys.getrecursionlimit()))
︡4fc7f6e9-ee21-4f01-b760-d772166dd114︡{"stdout":"recursion limit = 10000\n"}︡{"done":true}︡
︠2a20ac76-ca7d-4051-9b05-c361eb3f05a2o︠
# Adleman algorithm for the discrete logarithm problem
listQ=[0,0,0,0]
rAlpha=[]
factP1=[]
objectA=0
listOfBeta=[]
s=0
def genQ(p=0):
    B=float(2**(sqrt(log(float(p))*log(log(float(p))))))
    B1=float(2**(2*sqrt(log(float(p))*log(log(float(p))))))
    print("B=%s"%B)
    print("B1=%s"%B1)
    listQ=[]
    q=1
    #generate list of prime q
    while q<B1:
        q=int(gap("NextPrimeInt("+str(q)+")"))
        if q<B1:
            listQ.append(q)
        #if len(listQ)>1:
        #   break
    print("listQ=")
    print(listQ)
    return(listQ)

def factors(p=0):
    factP1=list(gap("Factors("+str(p-1)+")"))
    factTmp=[]
    for i in range(len(factP1)):
        if (factP1[i] not in factP1[:i]):
            factTmp.append(factP1[i])
    #print("factTmp=")
    #print(factTmp)
    countTmp=[factP1.count(k) for k in factTmp]
    #print("countTmp=")
    #print(countTmp)
    factP1=list(map(lambda x,y:x**y,factTmp,countTmp))
    print("fact(%s)="%(p-1))
    print(factP1)
    return(factP1)

class AlphaCond(tr.Condition):
    def __init__(self,listQ=listQ,p=0):
        tr.Condition.__init__(self)
        self.listQ=listQ
        self.leftAr=0
        self.listAlpha=[]
        #self.listOfR=[]
    
    def cond(self,first):
        first=first.astype(int)
        rightAr=reduce(lambda res,x:res*x,map(lambda x,y:x**y,self.listQ,first),1)
        rightAr=int(gap(""+str(int(rightAr))+" mod "+str(p)))
        if(rightAr==self.leftAr[1]):
            if(list(first) not in self.listAlpha):
                self.listAlpha.append(list(first))
            return(True)
        else:
            return(False)

def findAlphas(listQ=listQ,tresholdAlpha=6,a=0,p=0):
    aa=ones((len(listQ)))#zeros
    listOfR=list(range(len(listQ)+1))#+1 len(listQ)
    listOfR=listOfR[1:]
    listAr=[int(gap(str(a**r)+" mod "+str(p))) for r in listOfR]
    listAr=map(lambda x,y:(x,y),listOfR,listAr)
    print("listAr=")
    print(listAr)
    print("a,p=%s,%s"%(a,p))
    #dictinary for storing solutions
    #for every a^r_{i} it contains list of possible alpha vectors
    rAlpha={}
    oAlphaCond=AlphaCond(listQ=listQ,p=p)
    searchAlpha=tr.Search(init=aa,object=oAlphaCond,treshold=tresholdAlpha,findAll=True)
    #step 2.0: find possible solutions
    for leftAr in listAr:
        searchAlpha.object.leftAr=leftAr
        searchAlpha.object.listAlpha=[]
        searchAlpha.listOfA=[aa]
        oo=searchAlpha.search()
        if oo:
            rAlpha[leftAr]=oo.listAlpha[:]
            #print("rAlpha[leftAr]=")
            #print(rAlpha[leftAr])
        else:
            print("fail!")
            break
    print("rAlpha.keys=")
    print(list(rAlpha.keys()))
    print("len(rAlpha)=")
    print([len(rAlpha[k]) for k in rAlpha.keys()] )
    #print("rAlpha[9]=")
    #print(rAlpha[9])
    return(rAlpha)

class MatrixCond(tr.Condition):
    def __init__(self,vectors,factors):
        tr.Condition.__init__(self)
        self.vectors=vectors
        self.matrix=[]
        self.listOfR=[]
        self.factors=factors
        
    def cond(self,first):
        keys=list(self.vectors.keys())#!!!
        first=first.astype(int)
        #choice vectors for all keys (i.e. all (r,a^r))
        m=matrix([self.vectors[keys[i]][first[i]] for i in range(len(keys))])
        ##print("m=")
        #print(m)
        #print("vector[keys[0]]=")
        #print(self.vectors[keys[0]])
        #vector r from (r,a^r)
        self.listOfR=[keys[i][0] for i in range(len(keys))]
        try:
            tmpMatrix=[]
            for pe in self.factors:
                strM="TransposedMat("+str((m.astype(int)).tolist())+")"
                mat=matrix(gap(strM))
                strM=str((mat.astype(int)).tolist())+'^-1 mod '+str(pe)
                #print("m1=")
                #print(strM)
                m1=matrix(gap(strM))
                #print("m=")
                #print(m)
                #print("mat=")
                #print(mat)
                tmpMatrix.append(mat)
            print("tmpMatrixTransposed=")
            print(tmpMatrix)
            self.matrix=tmpMatrix[:]
            return(True)
        except:
            return(False)

def findUnsingularMatrix(rAlpha=rAlpha,listQ=listQ,factors=factP1,tresholdMatrix=6):
    aa=ones((len(listQ)))
    print("help")
    #step 2.1: find unsingular matrix
    o=MatrixCond(rAlpha,factors)
    search=tr.Search(init=aa,object=o,treshold=tresholdMatrix)
    s=search.search()
    #print("s=")
    #print(s)
    if s:
        return(s)

def findBeta(listQ=listQ,treshold=6,a=0,b=0,p=0):
    aa=ones((len(listQ)))#zeros
    oBetaCond=AlphaCond(listQ=listQ,p=p)
    print("a,b,p=%s,%s %s"%(a,b,p))
    oBetaCond.leftAr=(0,int(gap(str((a**3)*b)+" mod "+str(p))))
    searchBeta=tr.Search(init=aa,object=oBetaCond,treshold=treshold)
    s=searchBeta.search()
    if s:
        #print(s.listAlpha[-1])
        listOfBeta=s.listAlpha[0][:]
        return((listOfBeta,3))#

def solveEqs(objectA=objectA,listOfBeta=listOfBeta,s=s):
    #step 3: find log(q_{j}) vectors
    listOfR=objectA.listOfR[:]
    print("listOfR=")
    print(listOfR)
    print("listOfBeta=")
    print(listOfBeta)
    m=[]
    for i in range(len(objectA.matrix)):
        strM=str((objectA.matrix[i].astype(int)).tolist())+'^-1 mod '+str(objectA.factors[i])
        print(strM)
        listOfAlpha=list(gap(strM+'*'+str(listOfBeta)+' mod '+str(objectA.factors[i])))
        print("listOfAlpha=")
        print(listOfAlpha)
        tmpM=sum(map(lambda x,y:x*y,listOfAlpha,listOfR))
        
        tmpM=int(gap(str(tmpM)+' mod '+str(objectA.factors[i])))
        print("tmpM,s=")
        print((tmpM,s))
        m.append(tmpM-s)
    return(m)

p=11
print("p=%s"%p)
a=6
b=7
#6^3=7 mod 11+
#2^5=6 mod 13-
#2^3=8 mod 11+#2^3=8 mod 11+

def logByAdleman(a=0,r=0,b=0,p=0,treshold=11):
    #step 0: generate list of prime q
    listQ=genQ(p=p)

    dim=len(listQ)
    print("dim=%s"%dim)

    #step 1: factors of p-1 
    factP1=factors(p=p)

    #step 2: find dict with r and possible vectors a(r) i.e:
    #a^{r_{i}}=q_{1}^a_{i,1}*...*q_{k}^a_{i,k}
    rAlpha=findAlphas(listQ=listQ,tresholdAlpha=treshold,a=a,p=p)#11

    #step 3: find matrix A and vector r
    objectA=findUnsingularMatrix(rAlpha=rAlpha,listQ=listQ,factors=factP1,tresholdMatrix=treshold)#11

    #step 4: find betas
    #a^{s}*b=q_{1}^beta_{1}*...*q_{k}^beta_{k} mod p
    listOfBeta,s=findBeta(listQ=listQ,treshold=treshold,a=a,b=b,p=p)

    #step 5: solve matrix equations and find m_{l}
    m=solveEqs(objectA=objectA,listOfBeta=listOfBeta,s=s)
    print("m=")
    print(m)
    print("factors=")
    print(factP1)
    
    #step 6:check
    checker=True
    for k in range(len(m)):
        left=int(gap("%s mod %s"%(r,factP1[k])))
        right=int(gap("%s mod %s"%(m[k],factP1[k])))
        print("%s and founded %s for mod %s=%s,%s"%(r,m[k],factP1[k],left,right))
        if(left==right):
            checker=checker and True
        else:
            checker=checker and False
    
    print("checker for %s^%s=%s mod %s is"%(a,r,b,p))
    print(checker)
    print("*****************")

#test1
#logByAdleman(a=6,r=3,b=7,p=11,treshold=7)
arbp=[(6,3,7,11)]
#arbp=[(6,3,7,11),(2,3,8,11),(7,3,2,11),(8,3,6,11)]
#arbp=[(2,5,6,13),(6,5,2,13),(7,5,11,13),(11,5,7,13)]
#arbp=[(2,7,11,13),(6,7,7,13),(7,7,6,13),(11,7,2,13)]
#tests
for (a,r,b,p) in arbp:
    try:
        logByAdleman(a=a,r=r,b=b,p=p,treshold=7)
    except:
        try:
            logByAdleman(a=a,r=r,b=b,p=p,treshold=11)
        except:
            print("FAILURE for a=%s,r=%s,b=%s,p=%s"%(a,r,b,p))
︡8cff8c5c-d53f-46c3-94cb-45a7b1bb594b︡{"stdout":"p=11\n"}︡{"stdout":"B=2.72860554991\nB1=7.44528824702\nlistQ=\n[2, 3, 5, 7]\ndim=4\nfact(10)=\n[2, 5]\nlistAr=\n[(1, 6), (2, 3), (3, 7), (4, 9)]\na,p=6,11\nlimit overflow"}︡{"stdout":"\nlimit overflow"}︡{"stdout":"\nlimit overflow"}︡{"stdout":"\nlimit overflow"}︡{"stdout":"\nrAlpha.keys=\n[(2, 3), (4, 9), (1, 6), (3, 7)]\nlen(rAlpha)=\n[7, 8, 7, 6]\nhelp\ntmpMatrixTransposed="}︡{"stdout":"\n[matrix([[2, 3, 3, 2],\n        [1, 1, 1, 3],\n        [1, 2, 1, 1],\n        [2, 1, 2, 1]], dtype=object), matrix([[2, 3, 3, 2],\n        [1, 1, 1, 3],\n        [1, 2, 1, 1],\n        [2, 1, 2, 1]], dtype=object)]\nfound\na,b,p=6,7 11\nfound"}︡{"stdout":"\nlistOfR=\n[2, 4, 1, 3]\nlistOfBeta=\n[1, 1, 2, 1]\n[[2, 3, 3, 2], [1, 1, 1, 3], [1, 2, 1, 1], [2, 1, 2, 1]]^-1 mod 2\nlistOfAlpha=\n[0, 1, 0, 0]\ntmpM,s=\n(0, 3)\n[[2, 3, 3, 2], [1, 1, 1, 3], [1, 2, 1, 1], [2, 1, 2, 1]]^-1 mod 5\nlistOfAlpha=\n[2, 1, 3, 0]\ntmpM,s=\n(1, 3)\nm=\n[-3, -2]\nfactors=\n[2, 5]\n3 and founded -3 for mod 2=1,1\n3 and founded -2 for mod 5=3,3\nchecker for 6^3=7 mod 11 is\nTrue\n*****************\n"}︡{"done":true}︡︡{"stdout":"\nlimit overflow"}︡{"stdout":"\nrAlpha.keys=\n[(2, 3), (4, 9), (1, 6), (3, 7)]\nlen(rAlpha)=\n[7, 8, 7, 6]\nhelp\ntmpMatrixTransposed="}︡{"stdout":"\n[matrix([[2, 3, 3, 2],\n        [1, 1, 1, 3],\n        [1, 2, 1, 1],\n        [2, 1, 2, 1]], dtype=object), matrix([[2, 3, 3, 2],\n        [1, 1, 1, 3],\n        [1, 2, 1, 1],\n        [2, 1, 2, 1]], dtype=object)]\nfound\na,b,p=6,7 11\nfound"}︡{"stdout":"\nlistOfR=\n[2, 4, 1, 3]\nlistOfBeta=\n[1, 1, 2, 1]\n[[2, 3, 3, 2], [1, 1, 1, 3], [1, 2, 1, 1], [2, 1, 2, 1]]^-1 mod 2\nlistOfAlpha=\n[0, 1, 0, 0]\ntmpM,s=\n(0, 3)\n[[2, 3, 3, 2], [1, 1, 1, 3], [1, 2, 1, 1], [2, 1, 2, 1]]^-1 mod 5\nlistOfAlpha=\n[2, 1, 3, 0]\ntmpM,s=\n(1, 3)\nm=\n[-3, -2]\nfactors=\n[2, 5]\n3 and founded -3 for mod 2=1,1\n3 and founded -2 for mod 5=3,3\nchecker for 6^3=7 mod 11 is\nTrue\n*****************\n"}︡{"done":true}
︠0db13680-4977-4bf3-ac29-c93d5b65da01io︠
#old bad version
n=17
p=gap("NextPrimeInt("+str(n)+")")
p=11
print("p=%s"%p)
a=6
b=7

B=float(exp(sqrt(log(float(p))*log(log(float(p))))))
B1=float(exp(2*sqrt(log(float(p))*log(log(float(p))))))
print("B=%s"%B)
print("B1=%s"%B1)

listQ=[]
q=1
#generate list of prime q
while q<B:
    q=int(gap("NextPrimeInt("+str(q)+")"))
    listQ.append(q)
    if len(listQ)>2:
        break
print("listQ=")
print(listQ)

dim=len(listQ)
print("dim=%s"%dim)
#generate pattern for degrees (i.e alphas: q**alphas)
aa=ones((len(listQ)))#zeros((len(listQ)))

#step 2.0
#class for found unsingular matrix
class MatrixCond(tr.Condition):
    def __init__(self,vectors):
        tr.Condition.__init__(self)
        self.vectors=vectors
        self.matrix=[]
        self.listOfR=[]
        
    def cond(self,first):
        keys=list(self.vectors.keys())#!!!
        first=first.astype(int)
        #print("first=")
        #print(first)
        #print("keys=")
        #print(keys)
        #print("vectors=")
        #print([len(self.vectors[keys[i]])  for i in range(len(keys))])
        
        m=matrix([self.vectors[keys[i]][first[i]] for i in range(len(keys))])#
        
        self.listOfR=[keys[i][0] for i in range(len(keys))]
        try:
            #linalg.inv(m)
            
            strM=str((m.astype(int)).tolist())+'^-1 mod '+str(5)
            m1=matrix(gap(strM))
            print("m5=")
            print(m1)
            strM=str((m.astype(int)).tolist())+'^-1 mod '+str(2)
            m2=matrix(gap(strM))
            print("m2=")
            print(m2)
            self.matrix.extend([m1,m2])
            
            return(True)
        except:
            return(False)
#class for finding possible solutions for equetions: a^r_{i}=\prod(q^alpha_{0}*...*q^alpha_{n})
class AlphaCond(tr.Condition):
    def __init__(self,listQ=listQ):
        tr.Condition.__init__(self)
        self.listQ=listQ
        self.leftAr=0
        self.listAlpha=[]
        #self.listOfR=[]
    
    def cond(self,first):
        first=first.astype(int)
        rightAr=reduce(lambda res,x:res*x,map(lambda x,y:x**y,self.listQ,first),1)
        rightAr=int(gap(""+str(int(rightAr))+" mod "+str(p)))
        if(rightAr==self.leftAr[1]):
            if(list(first) not in self.listAlpha):
                self.listAlpha.append(list(first))
                
            #if(self.leftAr[0] not in self.listOfR):
            #    self.listOfR.append(self.leftAr[0])
            return(True)
        else:
            return(False)
        
def findLogs(listQ=listQ,tresholdAlpha=6,tresholdMatrix=6):
    aa=ones((len(listQ)))#zeros
    listOfR=list(range(len(listQ)))#len(listQ)
    listAr=[int(gap(""+str(a**r)+" mod "+str(p))) for r in listOfR]
    listAr=map(lambda x,y:(x,y),listOfR,listAr)
    print("listAr=")
    print(listAr)
    #dictinary for storing solutions
    #for every a^r_{i} it contains list of possible alpha vectors
    rAlpha={}
    oAlphaCond=AlphaCond(listQ=listQ)
    searchAlpha=tr.Search(init=aa,object=oAlphaCond,treshold=tresholdAlpha,findAll=True)
    #step 2.0: find posible solutions
    for leftAr in listAr:
        searchAlpha.object.leftAr=leftAr
        searchAlpha.object.listAlpha=[]
        searchAlpha.listOfA=[aa]
        oo=searchAlpha.search()
        if oo:
            rAlpha[leftAr]=oo.listAlpha[:]
            print("rAlpha[leftAr]=")
            print(rAlpha[leftAr])
        else:
            print("fail!")
            break

    #step 2.1: find unsingular matrix
    o=MatrixCond(rAlpha)
    
    print("rAlpha.keys=")
    print(list(rAlpha.keys()))
    print("len(rAlpha)=")
    print([len(rAlpha[k]) for k in rAlpha.keys()] )
    #print("rAlpha[9]=")
    #print(rAlpha[9])
    search=tr.Search(init=aa,object=o,treshold=tresholdMatrix)
    s=search.search()

    #step 3: find log(q_{j}) vectors
    if s:
        listOfR=o.listOfR[:]
        print("new listOfR=")
        print(listOfR)
        strM=str((s.matrix[0].astype(int)).tolist())+'^-1 mod '+str(5)
        print(strM)
        listOfLogsQ=gap(strM+'*'+str(listOfR)+' mod '+str(5))
        print("listOfLogsQ5=")
        print(listOfLogsQ)
        
        strM=str((s.matrix[1].astype(int)).tolist())+'^-1 mod '+str(2)
        print(strM)
        listOfLogsQ=gap(strM+'*'+str(listOfR)+' mod '+str(2))
        print("listOfLogsQ2=")
        print(listOfLogsQ)
        return(listOfLogsQ)
    #else:
    #    findLogs(tresholdAlpha=tresholdAlpha,tresholdMatrix=tresholdMatrix)

listOfLogsQ=findLogs(tresholdAlpha=7,tresholdMatrix=6)


︡f0656b94-f35f-4adc-880e-beae221c6a0f︡{"stdout":"p=11\n"}︡{"stdout":"B=4.25529398874\n"}︡{"stdout":"B1=18.1075269306\n"}︡{"stdout":"listQ=\n"}︡{"stdout":"[2, 3, 5]\n"}︡{"stdout":"dim=3\n"}︡{"stdout":"listAr=\n[(0, 1), (1, 6), (2, 3)]\nlimit overflow"}︡{"stdout":"\nrAlpha[leftAr]=\n[[2, 3, 1], [4, 1, 2], [2, 2, 3]]\nlimit overflow"}︡{"stdout":"\nrAlpha[leftAr]=\n[[1, 3, 1], [3, 1, 2], [1, 2, 3], [1, 1, 5]]\nlimit overflow"}︡{"stdout":"\nrAlpha[leftAr]=\n[[2, 1, 2], [2, 4, 1], [6, 1, 1]]\nrAlpha.keys=\n[(0, 1), (2, 3), (1, 6)]\nlen(rAlpha)=\n[3, 3, 4]\nm5=\n[[1 0 4]\n [2 1 0]\n [0 2 2]]"}︡{"stdout":"\nm2=\n[[1 0 1]\n [1 0 0]\n [0 1 0]]"}︡{"stdout":"\nfound\nnew listOfR=\n[0, 2, 1]\n[[1, 0, 4], [2, 1, 0], [0, 2, 2]]^-1 mod 5\nlistOfLogsQ5=\n[ 4, 4, 4 ]\n[[1, 0, 1], [1, 0, 0], [0, 1, 0]]^-1 mod 2\nlistOfLogsQ2=\n[ 0, 1, 0 ]\n"}︡{"done":true}︡
︠766ecc20-9b7c-4ecb-8bf2-fb80d719a9ab︠
#step 4.0:choice p_{k}
listP=[]
pk=int(B+1)

#generate list of prime q
while pk<B1:
    pk=int(gap("NextPrimeInt("+str(pk)+")"))
    listP.append(pk)
    if len(listP)>0:
        break
#listP=listP[1:]
print("listP=")
print(listP)

#step 4.1: generate listOfBeta
class BetaCond(tr.Condition):
    def __init__(self,listQ=listQ,listP=listP):
        tr.Condition.__init__(self)
        self.listQ=listQ
        self.multP=reduce(lambda x,res:x*res,listP,1)
        self.leftAr=int(gap(str((a**3)*b)+" mod "+str(p)))
        self.listAlpha=[]
    
    def cond(self,first):
        first=first.astype(int)
        rightAr=reduce(lambda res,x:res*x,map(lambda x,y:x**y,self.listQ,first),self.multP)
        rightAr=int(gap(str(int(rightAr))+" mod "+str(p)))
        if(rightAr==self.leftAr):
            if(list(first) not in self.listAlpha):
                self.listAlpha.append(list(first))
                print("betas=")
                print(self.listAlpha)
            #self.listAlpha.append(list(first))
            return(True)
        else:
            return(False)
oBetaCond=BetaCond()
#aa=ones((len(listP)))
searchBeta=tr.Search(init=aa,object=oBetaCond,treshold=6)
s=searchBeta.search()
if s:
    print(s.listAlpha[-1])
    listOfBeta=s.listAlpha[0][:]
#step 4.2: finding log_{a}(p_{i})
listOfLogsP=findLogs(listQ=listP,tresholdAlpha=11,tresholdMatrix=7)

print(1)
︡9b5f4b30-d4aa-42e5-8dea-cbbfdbdc3b1f︡{"stdout":"listP=\n"}︡{"stdout":"[7]\n"}︡{"stdout":"betas=\n[[1, 1, 2]]\nfound\n"}︡{"stdout":"[1, 1, 2]\n"}︡{"stdout":"listAr=\n[(0, 1)]\nlimit overflow\nrAlpha[leftAr]=\n[[10]]\nrAlpha.keys=\n[(0, 1)]\nlen(rAlpha)=\n[1]\n"}︡{"stderr":"Error in lines 42-42\nTraceback (most recent call last):\n  File \"/projects/sage/sage-6.10/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 905, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\n  File \"\", line 35, in findLogs\n  File \"tree.py\", line 26, in search\n    cond=self.object.cond(first)\n  File \"\", line 16, in cond\nIndexError: list index out of range\n"}︡{"done":true}︡
︠6c8aab3a-e341-499c-be05-573d592c6516i︠
self.listAlpha#step 5:find log_{a}(b)
print("listOfBeta=")
print(listOfBeta)
print("listOfLogsQ=")
print(listOfLogsQ)
print("listOfLogsP=")
print(listOfLogsP)

logAOfB=-2+sum(map(lambda x,y:x*y,listOfBeta,listOfLogsQ))+sum(list(listOfLogsP))
print(logAOfB)
logAOfB=int(gap(str(int(logAOfB))+" mod "+str(p-1)))
print("logAOfB=%s"%logAOfB)

︡867b35ed-9154-4d4a-9fb2-904777823def︡{"stdout":"listOfBeta=\n"}︡{"stdout":"[2, 3]\n"}︡{"stdout":"listOfLogsQ=\n"}︡{"stdout":"[ 1, 1 ]\n"}︡{"stdout":"listOfLogsP=\n"}︡{"stdout":"[ 1, 1 ]\n"}︡{"stdout":"5\n"}︡{"stdout":"logAOfB=5\n"}︡{"done":true}︡
︠931df392-4397-45b2-bac3-71f017f5613bi︠

l=[int(gap(str(3**r)+" mod "+str(19))) for r in range(4)]
print(p)
print(map(lambda x,y:(x,y),l,list(range(4))))
strM="[[1,0],[0,1]]"
t=list(gap(strM+' mod '+str(2)))
map(lambda x,y:x+y,t,t)
print(t)

︡9af6240e-34e4-4e5b-a6d4-2d67985a0121︡{"stdout":"11\n"}︡{"stdout":"[(1, 0), (3, 1), (9, 2), (8, 3)]\n"}︡{"stdout":"[[ 2, 0 ], [ 0, 2 ]]\n"}︡{"stdout":"[[ 1, 0 ], [ 0, 1 ]]\n"}︡{"done":true}︡
︠de901eef-ad77-4c7d-a29d-10947bf7287fsi︠
'''listG=gap('AllSmallGroups(27)')
for g in listG:
    if not g.IsCyclic():
           print("IdGroup: %s \n LowerCentralSeries %s"%(g.IdGroup(),g.LowerCentralSeries()))
'''        


'''
G = gap('Group((1,2,3)(4,5), (3,4))')
G.IsCyclic()
G.IdGroup()
G.LowerCentralSeries()
vectors={0:[array([1,0]),array([0,1])],
        1.5:[array([1,0]),array([0,1])]}
first=[1,0]
keys=list(vectors.keys())
m=matrix([vectors[keys[i]][first[i]] for i in range(len(keys))])

MS=MatrixSpace(GF(7),2)
mS=MS((m.astype(int)).tolist())
#print(mS.inverse())
#print(vector)
v=vector([1,2])
#print(v)
strM=str((m.astype(int)).tolist())+'^-1 mod '+str(7)
#print(strM)
gap(strM)
'''





︡cb71c40b-3eb5-49b8-a9f7-a3bc694128c7︡{"stdout":"'listG=gap(\\'AllSmallGroups(27)\\')\\nfor g in listG:\\n    if not g.IsCyclic():\\n           print(\"IdGroup: %s \\n LowerCentralSeries %s\"%(g.IdGroup(),g.LowerCentralSeries()))\\n'\n"}︡{"stdout":"\"\\nG = gap('Group((1,2,3)(4,5), (3,4))')\\nG.IsCyclic()\\nG.IdGroup()\\nG.LowerCentralSeries()\\nvectors={0:[array([1,0]),array([0,1])],\\n        1.5:[array([1,0]),array([0,1])]}\\nfirst=[1,0]\\nkeys=list(vectors.keys())\\nm=matrix([vectors[keys[i]][first[i]] for i in range(len(keys))])\\n\\nMS=MatrixSpace(GF(7),2)\\nmS=MS((m.astype(int)).tolist())\\n#print(mS.inverse())\\n#print(vector)\\nv=vector([1,2])\\n#print(v)\\nstrM=str((m.astype(int)).tolist())+'^-1 mod '+str(7)\\n#print(strM)\\ngap(strM)\\n\"\n"}︡{"done":true}︡
︠8d86e1b5-f1b5-40ce-aade-7360d012b908︠
︡ef9cd01e-0f2c-48ca-b556-2a836792f5c4︡{"done":true}︡
︠9491896a-bfc3-431f-8667-a51155067f7b︠









